// komplex.cpp:      Demonstration komplexer Zahlen
// ----------------------------------------------------
#include <complex>
#include <iostream>
using namespace std;

int main()
{                             // Konstruktoren:
  complex<long double> zld;   // Real- und Imaginrteil: 0
  complex<double> zd1(1.0);   // Imaginrteil: 0 
  complex<float> zf1(1.0f, 1.0f);    

                              //  Kopierkonstruktoren:
  complex<float>  zf2(zf1);   //  gleiche Typen
  complex<double> zd2(zf2);   // "kleiner" -> "grer"
  complex<double> zd3(zld);   // "grer" -> kleiner"

  cout << "zf1 =               " << zf1 << endl;
  cout << "zf2 =               " << zf2 << endl; 
  cout << "zf1 + zf2 =         " << zf1 + zf2 << endl;
  cout << "\nzd1 =               " << zd1 << endl;
  cout << "zd2 =               " << zd2 << endl;
  cout << "zd1 - zd2 =         " << zd1 - zd2 << endl;

  cout << "Geben Sie eine komplexe Zahl ein "
       << "(Format: x, (x) oder (x,y)):" << endl;
  cin >> zf1; 
  cout << "Ihre Eingabe: zf1 = " << zf1 << endl;
  cout << "zf2 =               " << zf2 << endl;
  cout << "zf1 * zf2 =         " << zf1 * zf2 << endl;

  if( zf2 != complex<float>(0.0, 0.0))
    cout << "zf1 / zf2 =         " << zf1 / zf2 << endl;
  
  return 0;
}
