// euler.cpp: Verwendung von sin(), cos(), exp()
//-----------------------------------------------------
#include <complex>
#include <iostream>
#include <iomanip>
using namespace std;

#define i complex<double>(0,1)     // Imaginre Einheit

int main()
{
   complex<double> z;

   cout << "  z       exp(iz)          sin(z)           cos(z)"
        << "          cos(z) + i*sin(z)\n";
   cout << setprecision(3);

   for(int x=0; x <= 1; x++)
      for(int y=0; y <= 1; y++)
      {
         z = complex<double>(x,y); 
         cout << left << setw(10) <<  z; 
         cout << left << setw(17) <<  exp( i*z); 
         cout << left << setw(17) <<  sin(z);
         cout << left << setw(17) <<  cos(z) 
              << cos(z) + i*sin(z) << endl;
      }

   return 0;
}
