// EuroDoll.cpp
// Ausgabe einer Kurstabelle:  Euro und US-$
// ------------------------------------------------------------

#include <iostream>
#include <iomanip>
using namespace std;

int main()
{
   long   euro, maxEuro;       // Euro-Betrge
   double kurs;                // Euro - $ -Kurs

   cout << "\n* * * KURSTABELLE Euro - US-$ * * *\n\n";

   cout << "\nBitte den Preis von einem Euro in US-$"
            " eingeben: ";
   cin >> kurs;
   cout << "\nBitte die Obergrenze fuer Euro eingeben: ";
   cin >> maxEuro;

   //  ---  Ausgabe der Tabelle  ---

                              // Spaltenberschriften:
   cout << '\n' << setw(12) << "Euro" << setw(20) << "US-$" 
        << "\t\tKurs: " << kurs << endl;

                              // Ausgabeformat fr $:
   cout << fixed << setprecision(2) << endl;

   long lower, upper,         // Unter- / Obergrenze
        step;                 // Schrittweite. 

         // Die uere Schleife bestimmt die aktuelle
         // Untergrenze und die Schrittweite:
   for( lower=1, step=1; lower <= maxEuro;
                         step*= 10, lower = 2*step)
         // Die innere Schleife gibt einen "Block" aus:
     for( euro = lower, upper = step*10; 
          euro <= upper && euro <= maxEuro; euro+=step)
       cout << setw(12) << euro
            << setw(20) << euro*kurs << endl;

/* mit while-Schleifen: 

         // Die uere Schleife bestimmt die aktuelle
         // Untergrenze und die Schrittweite:
   lower=1, step=1;
   while( lower <= maxEuro)
   {
         // Die innere Schleife gibt einen "Block" aus:
     euro = lower;
     upper = step*10;
     while( euro <= upper && euro <= maxEuro)
     {
       cout << setw(12) << euro
            << setw(20) << euro*kurs << endl;
       euro += step;
     }
     step *= 10, lower = 2*step;
   }
*/
   return 0;
}
