//  ball1.cpp
//  Simuliert einen springenden Ball
//  Hinweis: Programm mit Strg+C beenden.
//  --------------------------------------------------
//  Damit die Steuerzeichen wirksam sind, mu ein
//  entsprechender Bildschirmtreiber geladen sein.
//  Dies ist auf allen gngigen Linux/UNIX-Systemen gegeben.
//  Unter Windows gilt das auch fr Programme, die in einer
//  Cygwin-Umgebung ablaufen.
//  Eine Lsung fr Windows finden Sie im Verzeichnis 
//  Source_mit_Visual_C++_20xx-Projekten\kap07.
// --------------------------------------------------- 

#include <iostream>
#include <string>
using namespace std;

#define DELAY  10000000L             // Verzgerung
#define CLS   (cout << "\033[2J")    // Bildschirm lschen
#define LOCATE(z,s) (cout <<"\033["<< z <<';'<< s <<'H')
        // Cursor in Zeile z und Spalte s positionieren

int main()
{
   int x = 2, y = 3, dx = 1, geschw = 0;
   string boden(79, '-'),
          header = "****  SPRINGENDER BALL  ****";

   CLS;
   LOCATE(1,25);  cout << header;
   LOCATE(25,1);  cout << boden;

   while(true)      // Ball "immer" springen lassen
   {
     LOCATE(y,x);
     cout << 'o' << endl;              // Ball anzeigen
     for( long warten = 0; warten < DELAY; ++warten)
       ;
     if(x == 1 || x == 79) dx = -dx;   // An einer Wand?
     if( y == 24 )                     // Am Boden?
     {
       geschw = - geschw;
       if( geschw == 0 ) geschw = -7;  // Neu anstossen
     }
     geschw += 1;                 // Beschleunigung = 1

     LOCATE(y,x); cout <<  ' ';   // Anzeige lschen
     y += geschw;  x += dx;       // Neue Position
   }
}
