// ref1.cpp 
// Zeigt die Definition und Verwendung von Referenzen.
// --------------------------------------------------

#include <iostream>
#include <string>
using namespace std;

float x = 10.7F;                           // global

int main()
{
   float  &rx = x;          // rx : lokale Referenz auf x
// double &ref = x;         // Fehler: Ungleicher Typ!

   rx *= 2;

   cout << "   x = " <<  x << endl
        << "  rx = " << rx << endl;  

   const float& cref = x;    // cref : read-only-Referenz

   cout << "cref = " <<  cref << endl;   // ok!
// ++cref;                   // Fehler: read-only!
   
   const string str = "Ich bin ein konstanter String!";
   
// str = "Das geht nicht!";  // Fehler: str konstant!
// string& text = str;       // Fehler: str konstant!
   const string& text = str; // ok!
 
   cout << text << endl;     // ok! text wird nur gelesen.

   return 0;
}
