// ------------------------------------------------------
// kasse.cpp : Simulation einer Registrier-Kasse
// ------------------------------------------------------

#include "product.h"

void registrieren();

int main()
{
   cout << "\nHier ist eine Kasse!" << endl;
   char c;
   while(true)
   {
       cin.sync();
       cout << "\nNoch ein Kunde (j/n)?   "; 
       cin  >> c;

       if(c == 'j' || c == 'J')
           registrieren();
       else 
           break;
   }
   return 0;
}


void registrieren()
{
    Product* v[100];
    
    int x, i, anzahl = 0;
    double sum = 0.0;

    for (i = 0; i < 100; i++)
    {
      cin.sync();
      cout << "\nWas ist der nchste Artikel?" << endl;
      cout << "  0 = Kein weiterer Artikel\n"
           << "  1 = Unverpackter Artikel\n"
           << "  2 = Verpackter Artikel\n"
           << "? " ;
      cin  >> x;
      
      if( x <= 0 || x >= 3) 
          break;

      switch(x)
      {
        case 2:
            v[i] = new PackedFood;
            v[i]->scanner();
            sum += ((PackedFood*)v[i])->getPreis();
            break;

        case 1:
           v[i] = new UnpackedFood;
           v[i]->scanner();
           sum += ((UnpackedFood*)v[i])->getPreis() 
                  * ((UnpackedFood*)v[i])->getGew();
           break;
      }
    }
    anzahl = i;
    for( i=0; i < anzahl; i++)           // Ausgabe
         v[i]->printer();

    cout << "\n-----------------------------"
         << fixed << setprecision(2)
         << "\nGesamtpreis:   " << sum << endl;
}
