// ----------------------------------------------------------------
// minvar.cpp
// Definition und Test der Funktion min(), die das Minimum
// von positiven ganzen Zahlen berechnet und zurckgibt. 
// Als Argumente erwartet die Funktion eine variable Anzahl von
// unsigned-int-Werten.
// Das letzte Argument mu die Zahl 0 sein.
// ----------------------------------------------------------------

#include <stdarg.h>

unsigned int min( unsigned int first, ... )
{
    unsigned int minarg, arg;
    va_list argptr;         // Zeiger auf die optionalen Argumente

    if( first == 0)
        return 0;

    va_start( argptr, first);

    minarg = first;

    while( (arg = va_arg(argptr, unsigned int) ) != 0)
        if( arg < minarg)
            minarg = arg;

    va_end (argptr);

    return minarg;
}

// ----- Ein kleines main() zum Testen ---------------

#include <iostream>
using namespace std;

int main()
{
    cout << "\nDas Minimum der Zahlen: 34  47  19  22  58  " 
         << "ist:  " << min(34, 47, 19, 22,58, 0)
         << endl;

    return 0;
}