// ----------------------------------------------------
// power.cpp 
// Definition und Aufruf einer eigenen Funktion pow() zur 
// Berechnung ganzzahliger Potenzen.
// berladung der Standard-Funktion pow()
// ----------------------------------------------------
#include <iostream>
#include <cmath>
using namespace std;

double pow(int basis, int exp);

int main()             // eigene Funktion pow() testen
{
   int  basis    = 0;
   int  exponent = 0;

   cout << "  **** Berechnet ganzzahlige Potenzen ****\n"
        << endl;

   cout << "Testwerte eingeben.\n"
        << "Basis (ganze Zahl):  ";  cin >> basis;
   cout << "Exponent (ganze Zahl):  ";  cin >> exponent;

   cout << "Ergebnis von " << basis << " hoch " << exponent 
        << " = " << pow( basis, exponent) << endl;

   cout << "Berechnung mit der Standard-Funktion: " 
        << pow( (double)basis, (double)exponent) << endl;

   cout << endl;

   return 0;
}

double pow(int basis, int exp)
{
    if( exp == 0)     return 1.0;

    if( basis == 0)
        if( exp > 0)  return 0.0;
        else          return HUGE_VAL;

    int n = abs(exp);
    double power = basis;
    for( int i = 2; i <= exp; ++i)
        power *= basis;

    if( exp < 0) 
      power = 1/power;

    return power;
}
