// mutex.cpp
// Demonstriert die Synchronisation von Speicherzugriffen
// -------------------------------------------------------
#include <thread>
#include <mutex> 
#include <string>     
#include <iostream>
using namespace std;

string s;               // Speicher fr konkurrierende Zugriffe
mutex mtx;              // Mutex global vereinbaren

void writeHallo()
{
    mtx.lock();
    s = "Hallo, hallo!";  cout << s << endl;
    mtx.unlock();
}

void writeBye()
{
     mtx.lock();
     s = "Bye, Bye!"; cout << s << endl;
     mtx.unlock();
}

int main()
{
    thread t1(writeHallo), t2(writeBye);
    t1.join();  t2.join();
}
