﻿//  toupper.cpp
//  Filter zur Umwandlung in Großbuchstaben.
//  Unter Unix/Linux (und Cygwin) ist UTF-8 der Zeichensatz zur
//  Ausfuehrungszeit. Die aktuelle lokale Umgebung kann mit
//  setlocale(LC_ALL, ""); eingestellt werden.
//  Beim Einlesen mit wcin werden UTF-8-Zeichen in UTF-16-Zeichen
//  vom Typ wchar_t umgewandelt. Bei der Ausgabe mit wcout in
//  umgekehrter Richtung.
//  towupper() wandelt auch deutsche Umlaute um, aber nicht das Zeichen ß.
//  Die Eingabe von der Tastatur unter Unix/Linux (bzw.Cygwin)
//  mit Strg+D beenden.
// ------------------------------------------------------------

#include <iostream>
#include <clocale>
#include <cwctype>
using namespace std;

int main()
{
   setlocale(LC_ALL, "");               // "de_DE.UTF-8"
   wchar_t wc;
   while ( wcin.get(wc))                // solange ein Zeichen 
   {                                    // gelesen werden kann.
      switch( wc ) 
      {
         case 0xDF:                        // Zeichen ß
                   wcout.put('S'); wc = 'S';
                   break;

         default:  wc = towupper(wc);      // andere Zeichen,
      }                                    // auch Umlaute.

      wcout.put(wc);          // umgewandeltes Zeichen ausgeben
   }
   return 0;
}
