// ----------------------------------------------------
// datum_t.cpp 
// Mit Objekten der Klasse Datum arbeiten.
// ----------------------------------------------------

#include "datum.h" 

#include <iostream>
using namespace std;

int main()
{
   Datum  today, birthday( 29, 1, 1927);
   const Datum d2000(1,1,2000);

   cout << "\nDer Geburtstag von Brigitte: "
        << birthday.asString() << endl;

   today.setDatum();
   cout << "\nDas heutige Datum : " << today.asString() << endl;;

   if( today.isLess( d2000))
      cout << "Guten Rutsch ins nchste Jahrtausend\n" << endl;
   else
      cout << "Alles Gute im neuen Jahrtausend\n" << endl;
       
   Datum holiday;
   int tag, monat, jahr;   char c;

   cout << "\nWann beginnt Ihr naechster Urlaub?\n"
        << "Eingabe im Format Tag.Monat.Jahr : ";
   
   if( !(cin >> tag >> c >> monat >> c >> jahr) )
      cerr << "Ungueltige Eingabe!\n" << endl;
   else if ( !holiday.setDatum( tag, monat, jahr))
      cerr << "Ungueltiges Datum!\n" << endl;
   else
   {
      cout << "\nIhr erster Urlaubstag: ";
      holiday.print();

      if( today.getJahr() < holiday.getJahr())
         cout << "Sie sollten noch in diesem Jahr Urlaub machen!\n"
              << endl;
      else
         cout << "Gute Reise!\n" << endl; 
   }
   return 0;
}
