// ---------------------------------------------------
// mitgl_t.cpp 
// Mit der Klasse Mitglied arbeiten.
// ---------------------------------------------------

#include "mitglied.h"      // Definition der Klasse

#include <iostream>
#include <string>
using namespace std;

int main()
{
   Datum heute; heute.setDatum();
   cout << "Datum: " << heute.asString() << endl;

   Mitglied franzi( 0, "Flott, Franzi", 17,11,81),
            kurt( 2222, "Hurtig, Kurt", Datum(3,5,77) );
   
   franzi.setNr(1111);

   cout << "\nZwei Mitglieder des Sportvereins:\n" << endl;
   franzi.display();
   kurt.display();

   cout << "\nEs hat sich etwas veraendert!" << endl;
   franzi.setName("Hurtig-Flott");
   franzi.display();

   Mitglied benny( 1122,"Hurtig, Benny", 1,1,2000);
   cout << "Das juengste Mitglied im Verein: \n";
   benny.display();
   
   // Vorstand? 
   cout << "\nWer ist der Vorstand des Vereins?\n"
        << "Mitgliedsnummer eingeben: ";
   int nr;
   Mitglied *ptr = NULL;

   if( cin >> nr)
   {
     if( nr == franzi.getNr())
         ptr = &franzi;  
     else if( nr == kurt.getNr())
         ptr = &kurt;  
     
     Mitglied::setVorstand( ptr);
   }
  
   cout << "\nDer Vorstand des Sportvereins:" << endl;

   ptr = Mitglied::getVorstand();
   if( ptr != NULL)
       ptr->display();
   else
       cout << "Kein Vorstand vorhanden!" << endl;
   
   return 0; 
}
