// fcopy1.cpp
// Kopiert Dateien
// Aufruf: fcopy1  quelldatei  [ zieldatei ]
// ----------------------------------------------------
#include <iostream>
#include <fstream>
using namespace std;

inline void openerror( const char *datei)
{
  cerr << "Fehler beim ffnen von " << datei << endl;
  exit(1);
}

void copy( istream& is, ostream& os);    // Prototyp

int main(int argc, char *argv[])
{
  if( argc < 2 || argc > 3)
  {
     cerr << "Aufruf: fcopy1 quelldatei [ zieldatei ]" 
          << endl;
     return 1;                      // oder: exit(1);
  } 
  ifstream infile(argv[1]);         // 1. Datei ffnen
  if( !infile.is_open()) 
     openerror( argv[1]);

  if( argc == 2)               // Nur eine Quelldatei.
     copy( infile, cout);
  else                         // Quell- und Zieldatei.
  {
     ofstream outfile(argv[2]);     // 2. Datei ffnen
     if( !outfile.is_open() )
        openerror( argv[2]);
     
     copy( infile, outfile);
     outfile.close();               // Hier unntig.
  }
  infile.close();                   // Hier unntig.

  return 0; 
}
 
void copy( istream& is, ostream& os)  // is nach os 
{                                     // kopieren.
  char c;
  while( is.get(c) ) 
      os.put(c);                  // oder:  os << c ; 
}
