// ---------------------------------------------
// prior_t.cpp : Zum Testen einer Priority Queue
// ---------------------------------------------

#include <queue>
#include <string>
#include <iostream>
using namespace std;

class Paket
{
  private:
    unsigned int prio;                 // Prioritt
    string info;

  public:
    Paket(unsigned int p, const string& s): prio(p), info(s) {}
   // Zugriffsmethoden, ...
   // berladene Operatoren:
  friend bool operator<( const Paket& x1, const Paket& x2)
  { return (x1.prio < x2.prio); }

  friend ostream& operator<<( ostream& os, const Paket& x)
  { os << x.prio << "  " <<  x.info;   return os; }
};

int main()
{
   priority_queue<Paket>  pq;

   pq.push(Paket(7,"Uwe"));    // Einfgen
   pq.push(Paket(1,"Peter"));
   pq.push(Paket(4,"Susanne"));
   
   while( !pq.empty() )
   {  
     cout << pq.top() << endl; // Anschauen
     pq.pop();                 // Lschen
   }
   return 0;
}
// Ausgabe:   7  Uwe
//            4  Susanne
//            1  Peter
